var $AdfCollections$$ = {$EMPTY_ARRAY$:[]};
$goog$exportSymbol$$("AdfCollections.EMPTY_ARRAY", $AdfCollections$$.$EMPTY_ARRAY$);
$AdfCollections$$.isArray = function $$AdfCollections$$$isArray$($array$$13$$) {
  return $array$$13$$ ? Array.prototype.isPrototypeOf($array$$13$$) : !1;
};
$goog$exportSymbol$$("AdfCollections.isArray", $AdfCollections$$.isArray);
$AdfCollections$$.clear = function $$AdfCollections$$$clear$($target$$78$$) {
  if ($target$$78$$) {
    for (var $i$$26$$ in $target$$78$$) {
      delete $target$$78$$[$i$$26$$];
    }
  }
};
$goog$exportSymbol$$("AdfCollections.clear", $AdfCollections$$.clear);
$AdfCollections$$.$isEmpty$ = function $$AdfCollections$$$$isEmpty$$($collection$$) {
  var $empty$$ = !0, $k$$1$$;
  for ($k$$1$$ in $collection$$) {
    if ($collection$$.hasOwnProperty($k$$1$$)) {
      $empty$$ = !1;
      break;
    }
  }
  return $empty$$;
};
$goog$exportSymbol$$("AdfCollections.isEmpty", $AdfCollections$$.$isEmpty$);
$AdfCollections$$.$clearArray$ = function $$AdfCollections$$$$clearArray$$($array$$14$$) {
  $array$$14$$.length = 0;
};
$goog$exportSymbol$$("AdfCollections.clearArray", $AdfCollections$$.$clearArray$);
$AdfCollections$$.$cloneArray$ = function $$AdfCollections$$$$cloneArray$$($source$$12$$) {
  return $source$$12$$ ? $AdfCollections$$.$copyInto$(Array($source$$12$$.length), $source$$12$$) : null;
};
$goog$exportSymbol$$("AdfCollections.cloneArray", $AdfCollections$$.$cloneArray$);
$AdfCollections$$.$copyInto$ = function $$AdfCollections$$$$copyInto$$($target$$79$$, $source$$13$$, $keyConverter$$) {
  if ($target$$79$$ && $source$$13$$ && $target$$79$$ !== $source$$13$$) {
    for (var $k$$2$$ in $source$$13$$) {
      var $targetKey$$;
      $targetKey$$ = $keyConverter$$ ? $keyConverter$$($k$$2$$) : $k$$2$$;
      try {
        $target$$79$$[$targetKey$$] = $source$$13$$[$k$$2$$];
      } catch ($e$$15$$) {
      }
    }
  }
  return $target$$79$$;
};
$goog$exportSymbol$$("AdfCollections.copyInto", $AdfCollections$$.$copyInto$);
$AdfCollections$$.$copyProperties$ = function $$AdfCollections$$$$copyProperties$$($target$$80$$, $source$$14$$, $sourceKeys$$, $keyConverter$$1$$) {
  if ($target$$80$$ && $source$$14$$ && $sourceKeys$$ && $target$$80$$ !== $source$$14$$) {
    for (var $keyCount$$ = $sourceKeys$$.length, $i$$27$$ = 0;$i$$27$$ < $keyCount$$;$i$$27$$++) {
      var $currKey_targetKey$$1$$ = $sourceKeys$$[$i$$27$$], $sourceValue$$ = $source$$14$$[$currKey_targetKey$$1$$];
      if ($sourceValue$$) {
        $currKey_targetKey$$1$$ = $keyConverter$$1$$ ? $keyConverter$$1$$($currKey_targetKey$$1$$) : $currKey_targetKey$$1$$;
        try {
          $target$$80$$[$currKey_targetKey$$1$$] = $sourceValue$$;
        } catch ($e$$16$$) {
        }
      }
    }
    return $target$$80$$;
  }
};
$goog$exportSymbol$$("AdfCollections.copyProperties", $AdfCollections$$.$copyProperties$);
$AdfCollections$$.$removeAll$ = function $$AdfCollections$$$$removeAll$$($targetCollection$$, $removeCollection$$, $outCollection$$) {
  $outCollection$$ ? $outCollection$$ !== $targetCollection$$ && $outCollection$$.clear() : $outCollection$$ = {};
  if (!$targetCollection$$) {
    return $outCollection$$;
  }
  $AdfCollections$$.$copyInto$($outCollection$$, $targetCollection$$);
  if ($removeCollection$$) {
    for (var $k$$3$$ in $removeCollection$$) {
      delete $outCollection$$[$k$$3$$];
    }
  }
  return $outCollection$$;
};
$goog$exportSymbol$$("AdfCollections.removeAll", $AdfCollections$$.$removeAll$);
$AdfCollections$$.$union$ = function $$AdfCollections$$$$union$$($inUnion1_outTarget$$, $inUnion2$$, $outUnion$$) {
  if (null == $inUnion1_outTarget$$ || null == $inUnion2$$) {
    return $inUnion1_outTarget$$ = null == $inUnion1_outTarget$$ ? $inUnion2$$ : $inUnion1_outTarget$$, $outUnion$$ && ($AdfCollections$$.clear($outUnion$$), $AdfCollections$$.$copyInto$($outUnion$$, $inUnion1_outTarget$$)), $inUnion1_outTarget$$;
  }
  $outUnion$$ ? $outUnion$$ !== $inUnion1_outTarget$$ && $outUnion$$ !== $inUnion2$$ && $AdfCollections$$.clear($outUnion$$) : $outUnion$$ = {};
  $AdfCollections$$.$copyInto$($outUnion$$, $inUnion1_outTarget$$);
  $AdfCollections$$.$copyInto$($outUnion$$, $inUnion2$$);
  return $outUnion$$;
};
$goog$exportSymbol$$("AdfCollections.union", $AdfCollections$$.$union$);
$AdfCollections$$.$getKeyOf$ = function $$AdfCollections$$$$getKeyOf$$($collection$$1$$, $value$$99$$) {
  if ($collection$$1$$) {
    for (var $k$$4$$ in $collection$$1$$) {
      if ($collection$$1$$[$k$$4$$] === $value$$99$$) {
        return $k$$4$$;
      }
    }
  }
};
$goog$exportSymbol$$("AdfCollections.getKeyOf", $AdfCollections$$.$getKeyOf$);
$AdfCollections$$.$removeValue$ = function $$AdfCollections$$$$removeValue$$($collection$$2$$, $value$$100$$) {
  var $key$$24$$ = $AdfCollections$$.$getKeyOf$($collection$$2$$, $value$$100$$);
  $key$$24$$ && delete $collection$$2$$[$key$$24$$];
  return $key$$24$$;
};
$goog$exportSymbol$$("AdfCollections.removeValue", $AdfCollections$$.$removeValue$);
$AdfCollections$$.$removeArrayValue$ = function $$AdfCollections$$$$removeArrayValue$$($array$$15$$, $value$$101$$) {
  if ($array$$15$$) {
    $AdfAssert$$.$assertArray$($array$$15$$);
    for (var $length$$25$$ = $array$$15$$.length, $i$$28$$ = 0;$i$$28$$ < $length$$25$$;$i$$28$$++) {
      if ($array$$15$$[$i$$28$$] == $value$$101$$) {
        return $array$$15$$.splice($i$$28$$, 1), $i$$28$$;
      }
    }
  }
  return -1;
};
$goog$exportSymbol$$("AdfCollections.removeArrayValue", $AdfCollections$$.$removeArrayValue$);
$AdfCollections$$.$removeArrayKey$ = function $$AdfCollections$$$$removeArrayKey$$($array$$16$$, $key$$25$$) {
  var $index$$51$$ = parseInt($key$$25$$);
  isNaN($index$$51$$) ? delete $array$$16$$[$key$$25$$] : $array$$16$$.splice($index$$51$$, 1);
};
$goog$exportSymbol$$("AdfCollections.removeArrayKey", $AdfCollections$$.$removeArrayKey$);
$AdfCollections$$.$addArrayKey$ = function $$AdfCollections$$$$addArrayKey$$($array$$17$$, $key$$26$$, $value$$102$$) {
  var $index$$52$$ = parseInt($key$$26$$);
  isNaN($index$$52$$) ? $array$$17$$[$key$$26$$] = $value$$102$$ : $array$$17$$.splice($index$$52$$, 0, $value$$102$$);
};
$goog$exportSymbol$$("AdfCollections.addArrayKey", $AdfCollections$$.$addArrayKey$);
$AdfCollections$$.indexOf = function $$AdfCollections$$$indexOf$($array$$18$$, $object$$6$$) {
  $AdfAssert$$.$assertArrayOrNull$($array$$18$$);
  if (!$array$$18$$) {
    return -1;
  }
  for (var $index$$53$$ = -1, $arraySize$$ = $array$$18$$.length, $i$$29$$ = 0;$i$$29$$ < $arraySize$$;$i$$29$$++) {
    if ($array$$18$$[$i$$29$$] == $object$$6$$) {
      $index$$53$$ = $i$$29$$;
      break;
    }
  }
  return $index$$53$$;
};
$goog$exportSymbol$$("AdfCollections.indexOf", $AdfCollections$$.indexOf);
$AdfCollections$$.lastIndexOf = function $$AdfCollections$$$lastIndexOf$($array$$19$$, $object$$7$$) {
  $AdfAssert$$.$assertArrayOrNull$($array$$19$$);
  if (!$array$$19$$) {
    return -1;
  }
  for (var $index$$54$$ = -1, $i$$30$$ = $array$$19$$.length - 1;0 <= $i$$30$$;$i$$30$$--) {
    if ($array$$19$$[$i$$30$$] == $object$$7$$) {
      $index$$54$$ = $i$$30$$;
      break;
    }
  }
  return $index$$54$$;
};
$goog$exportSymbol$$("AdfCollections.lastIndexOf", $AdfCollections$$.lastIndexOf);
